import * as React from 'react';
import { IgrDropdownGroup } from "./igr-dropdown-group";
import { SelectGroup } from "./SelectGroup";
import { IgcSelectGroupComponent, defineComponents } from "igniteui-webcomponents";
import { IgrSelectItem } from "./igr-select-item";
import { ensureBool } from "igniteui-react-core";
/**

*/
export class IgrSelectGroup extends IgrDropdownGroup {
    createImplementation() {
        return new SelectGroup();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
        defineComponents(IgcSelectGroupComponent);
    }
    componentDidMount() {
        this.i.nativeElement = this._elRef;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("igc-select-group", {
            ref: this._getMainRef,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
    /**
     * All child `igc-select-item`s.
    */
    get items() {
        if (!this.i.g) {
            return undefined;
        }
        let ret = [];
        for (let i = 0; i < this.i.g.length; i++) {
            let impl = this.i.g[i];
            if (!impl.externalObject) {
                let e = IgrSelectItem._createFromInternal(impl);
                e._implementation = impl;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
    set items(v) {
        let arr = [];
        for (let i = 0; i < v.length; i++) {
            arr.push(v[i].i);
        }
        this.i.g = arr;
    }
    /**
     * Whether the group item and all its children are disabled.
    */
    get disabled() {
        return this.i.h;
    }
    set disabled(v) {
        this.i.h = ensureBool(v);
    }
    disconnectedCallback() {
        this.i.i();
    }
}
