import * as React from 'react';
import { IgrDropdownHeader } from "./igr-dropdown-header";
import { SelectHeader } from "./SelectHeader";
import { IgcSelectHeaderComponent, defineComponents } from "igniteui-webcomponents";
/**

*/
export class IgrSelectHeader extends IgrDropdownHeader {
    createImplementation() {
        return new SelectHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
        defineComponents(IgcSelectHeaderComponent);
    }
    componentDidMount() {
        this.i.nativeElement = this._elRef;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("igc-select-header", {
            ref: this._getMainRef,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
}
