import { IgrContentPane } from "./igr-content-pane";
import { UnpinnedLocation_$type } from "./UnpinnedLocation";
import { PanePinnedEventArgsDetail as PanePinnedEventArgsDetail_internal } from "./PanePinnedEventArgsDetail";
import { ensureBool, ensureEnum } from "igniteui-react-core";
var IgrPanePinnedEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrPanePinnedEventArgsDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPanePinnedEventArgsDetail.prototype.createImplementation = function () {
        return new PanePinnedEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPanePinnedEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPanePinnedEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrPanePinnedEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPanePinnedEventArgsDetail.prototype, "sourcePane", {
        /**
         * Gets the source pane that triggers the pinned state change.
        */
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrContentPane._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPanePinnedEventArgsDetail.prototype, "panes", {
        /**
         * Gets/sets the panes that are about to get pinned/unpinned.
        */
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                if (!impl.externalObject) {
                    var e = IgrContentPane._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPanePinnedEventArgsDetail.prototype, "newValue", {
        /**
         * Gets the new pinned value.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPanePinnedEventArgsDetail.prototype, "location", {
        /**
         * Gets the unpinned location.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureEnum(UnpinnedLocation_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    IgrPanePinnedEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.sourcePane && this.sourcePane.name && this.sourcePane.name == name) {
            return this.sourcePane;
        }
        return null;
    };
    IgrPanePinnedEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPanePinnedEventArgsDetail;
}());
export { IgrPanePinnedEventArgsDetail };
