import { __extends } from "tslib";
import * as React from 'react';
import { IgrDropdownGroup } from "./igr-dropdown-group";
import { SelectGroup } from "./SelectGroup";
import { IgcSelectGroupComponent, defineComponents } from "igniteui-webcomponents";
import { IgrSelectItem } from "./igr-select-item";
import { ensureBool } from "igniteui-react-core";
/**

*/
var IgrSelectGroup = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSelectGroup, _super);
    function IgrSelectGroup(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        defineComponents(IgcSelectGroupComponent);
        return _this;
    }
    IgrSelectGroup.prototype.createImplementation = function () {
        return new SelectGroup();
    };
    Object.defineProperty(IgrSelectGroup.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSelectGroup.prototype.componentDidMount = function () {
        this.i.nativeElement = this._elRef;
        _super.prototype.componentDidMount.call(this);
    };
    IgrSelectGroup.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("igc-select-group", {
            ref: this._getMainRef,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrSelectGroup.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    Object.defineProperty(IgrSelectGroup.prototype, "items", {
        /**
         * All child `igc-select-item`s.
        */
        get: function () {
            if (!this.i.g) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.g.length; i++) {
                var impl = this.i.g[i];
                if (!impl.externalObject) {
                    var e = IgrSelectItem._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.g = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSelectGroup.prototype, "disabled", {
        /**
         * Whether the group item and all its children are disabled.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrSelectGroup.prototype.disconnectedCallback = function () {
        this.i.i();
    };
    return IgrSelectGroup;
}(IgrDropdownGroup));
export { IgrSelectGroup };
