import { __extends } from "tslib";
import * as React from 'react';
import { IgrDropdownHeader } from "./igr-dropdown-header";
import { SelectHeader } from "./SelectHeader";
import { IgcSelectHeaderComponent, defineComponents } from "igniteui-webcomponents";
/**

*/
var IgrSelectHeader = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSelectHeader, _super);
    function IgrSelectHeader(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        defineComponents(IgcSelectHeaderComponent);
        return _this;
    }
    IgrSelectHeader.prototype.createImplementation = function () {
        return new SelectHeader();
    };
    Object.defineProperty(IgrSelectHeader.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSelectHeader.prototype.componentDidMount = function () {
        this.i.nativeElement = this._elRef;
        _super.prototype.componentDidMount.call(this);
    };
    IgrSelectHeader.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("igc-select-header", {
            ref: this._getMainRef,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrSelectHeader.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    return IgrSelectHeader;
}(IgrDropdownHeader));
export { IgrSelectHeader };
