import * as React from 'react';
import { AvatarShape } from "./AvatarShape";
import { SizableComponentSize } from "./SizableComponentSize";
import { Avatar } from "./Avatar";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * An avatar component is used as a representation of a user identity
 * typically in a user profile.
*/
export declare class IgrAvatar<P extends IIgrAvatarProps = IIgrAvatarProps> extends React.Component<P, {}> {
    protected createImplementation(): Avatar;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Avatar; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrAvatar;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The image source to use.
    */
    get src(): string;
    set src(v: string);
    /**
     * Alternative text for the image.
    */
    get alt(): string;
    set alt(v: string);
    /**
     * Initials to use as a fallback when no image is available.
    */
    get initials(): string;
    set initials(v: string);
    /**
     * The shape of the avatar.
    */
    get shape(): AvatarShape;
    set shape(v: AvatarShape);
    get size(): SizableComponentSize;
    set size(v: SizableComponentSize);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrAvatarProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The image source to use.
    */
    src?: string;
    /**
     * Alternative text for the image.
    */
    alt?: string;
    /**
     * Initials to use as a fallback when no image is available.
    */
    initials?: string;
    /**
     * The shape of the avatar.
    */
    shape?: AvatarShape | string;
    size?: SizableComponentSize | string;
}
