import * as React from 'react';
import { InputType } from "./InputType";
import { InputInputmode } from "./InputInputmode";
import { IgrComponentValueChangedEventArgs } from "./igr-component-value-changed-event-args";
import { IgrInputBase, IIgrInputBaseProps } from "./igr-input-base";
import { Input } from "./Input";
/**

*/
export declare class IgrInput extends IgrInputBase<IIgrInputProps> {
    protected createImplementation(): Input;
    /**
                                 * @hidden
                                 */
    get i(): Input;
    constructor(props: IIgrInputProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The value of the control.
    */
    get value(): string;
    set value(v: string);
    /**
     * The type attribute of the control.
    */
    get displayType(): InputType;
    set displayType(v: InputType);
    /**
     * The input mode attribute of the control.
    */
    get inputmode(): InputInputmode;
    set inputmode(v: InputInputmode);
    /**
     * The pattern attribute of the control.
    */
    get pattern(): string;
    set pattern(v: string);
    /**
     * Controls the validity of the control.
    */
    get invalid(): boolean;
    set invalid(v: boolean);
    /**
     * The minlength attribute of the control.
    */
    get minlength(): number;
    set minlength(v: number);
    /**
     * The maxlength attribute of the control.
    */
    get maxlength(): number;
    set maxlength(v: number);
    /**
     * The min attribute of the control.
    */
    get min(): string;
    set min(v: string);
    /**
     * The max attribute of the control.
    */
    get max(): string;
    set max(v: string);
    /**
     * The step attribute of the control.
    */
    get step(): number;
    set step(v: number);
    /**
     * The autofocus attribute of the control.
    */
    get autofocus(): boolean;
    set autofocus(v: boolean);
    /**
     * The autocomplete attribute of the control.
    */
    get autocomplete(): string;
    set autocomplete(v: string);
    get tabIndex(): number;
    set tabIndex(v: number);
    /**
     * Checks for validity of the control and shows the browser message if it's invalid.
    
    */
    reportValidity(): void;
    /**
     * Checks for validity of the control and emits the invalid event if it invalid.
    
    */
    checkValidity(): void;
    /**
     * Sets a custom validation message for the control.
     * As long as `message` is not empty, the control is considered invalid.
    
    */
    setCustomValidity(message: string): void;
    /**
     * Selects all text within the input.
    
    */
    select(): void;
    /**
     * Increments the numeric value of the input by one or more steps.
    
    */
    stepUp(n: number): void;
    /**
     * Decrements the numeric value of the input by one or more steps.
    
    */
    stepDown(n: number): void;
    private _change;
    private _change_wrapped;
    get change(): (s: IgrInput, e: IgrComponentValueChangedEventArgs) => void;
    set change(ev: (s: IgrInput, e: IgrComponentValueChangedEventArgs) => void);
}
export interface IIgrInputProps extends IIgrInputBaseProps {
    /**
     * The value of the control.
    */
    value?: string;
    /**
     * The type attribute of the control.
    */
    displayType?: InputType | string;
    /**
     * The input mode attribute of the control.
    */
    inputmode?: InputInputmode | string;
    /**
     * The pattern attribute of the control.
    */
    pattern?: string;
    /**
     * Controls the validity of the control.
    */
    invalid?: boolean | string;
    /**
     * The minlength attribute of the control.
    */
    minlength?: number | string;
    /**
     * The maxlength attribute of the control.
    */
    maxlength?: number | string;
    /**
     * The min attribute of the control.
    */
    min?: string;
    /**
     * The max attribute of the control.
    */
    max?: string;
    /**
     * The step attribute of the control.
    */
    step?: number | string;
    /**
     * The autofocus attribute of the control.
    */
    autofocus?: boolean | string;
    /**
     * The autocomplete attribute of the control.
    */
    autocomplete?: string;
    tabIndex?: number | string;
    change?: (s: IgrInput, e: IgrComponentValueChangedEventArgs) => void;
}
