import { IgrInputBase, IIgrInputBaseProps } from "./igr-input-base";
import { MaskInputBase } from "./MaskInputBase";
export declare abstract class IgrMaskInputBase<P extends IIgrMaskInputBaseProps = IIgrMaskInputBaseProps> extends IgrInputBase<P> {
    /**
                                 * @hidden
                                 */
    get i(): MaskInputBase;
    constructor(props: P);
    /**
     * The prompt symbol to use for unfilled parts of the mask.
    */
    get prompt(): string;
    set prompt(v: string);
    /**
     * Controls the validity of the control.
    */
    get invalid(): boolean;
    set invalid(v: boolean);
    connectedCallback(): void;
    /**
     * Sets a custom validation message for the control.
     * As long as `message` is not empty, the control is considered invalid.
    
    */
    setCustomValidity(message: string): void;
    /**
     * Selects all text within the input.
    
    */
    select(): void;
}
export interface IIgrMaskInputBaseProps extends IIgrInputBaseProps {
    /**
     * The prompt symbol to use for unfilled parts of the mask.
    */
    prompt?: string;
    /**
     * Controls the validity of the control.
    */
    invalid?: boolean | string;
}
