import * as React from 'react';
import { NavDrawerHeaderItem } from "./NavDrawerHeaderItem";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * A wrapper for navigation drawer's header.
*/
export declare class IgrNavDrawerHeaderItem<P extends IIgrNavDrawerHeaderItemProps = IIgrNavDrawerHeaderItemProps> extends React.Component<P, {}> {
    protected createImplementation(): NavDrawerHeaderItem;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): NavDrawerHeaderItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrNavDrawerHeaderItem;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrNavDrawerHeaderItemProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
