import * as React from 'react';
import { NavDrawerItem } from "./NavDrawerItem";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents a navigation drawer item.
*/
export declare class IgrNavDrawerItem<P extends IIgrNavDrawerItemProps = IIgrNavDrawerItemProps> extends React.Component<P, {}> {
    protected createImplementation(): NavDrawerItem;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): NavDrawerItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrNavDrawerItem;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Determines whether the drawer is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Determines whether the drawer is active.
    */
    get active(): boolean;
    set active(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    connectedCallback(): void;
}
export interface IIgrNavDrawerItemProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Determines whether the drawer is disabled.
    */
    disabled?: boolean | string;
    /**
     * Determines whether the drawer is active.
    */
    active?: boolean | string;
}
