import * as React from 'react';
import { IgrRangeSliderValueEventArgs } from "./igr-range-slider-value-event-args";
import { IgrSliderBase, IIgrSliderBaseProps } from "./igr-slider-base";
import { RangeSlider } from "./RangeSlider";
/**
 * A range slider component used to select two numeric values within a range.
*/
export declare class IgrRangeSlider extends IgrSliderBase<IIgrRangeSliderProps> {
    protected createImplementation(): RangeSlider;
    /**
                                 * @hidden
                                 */
    get i(): RangeSlider;
    constructor(props: IIgrRangeSliderProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get lower(): number;
    set lower(v: number);
    get upper(): number;
    set upper(v: number);
    /**
     * The aria label of the lower thumb.
    */
    get ariaLabelLower(): string;
    set ariaLabelLower(v: string);
    /**
     * The aria label of the upper thumb.
    */
    get ariaLabelUpper(): string;
    set ariaLabelUpper(v: string);
    private _input;
    private _input_wrapped;
    /**
     * Emitted when a value is changed via thumb drag or keyboard interaction.
    */
    get input(): (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void;
    set input(ev: (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void);
    private _change;
    private _change_wrapped;
    /**
     * Emitted when a value change is committed on a thumb drag end or keyboard interaction.
    */
    get change(): (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void;
    set change(ev: (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void);
}
export interface IIgrRangeSliderProps extends IIgrSliderBaseProps {
    lower?: number | string;
    upper?: number | string;
    /**
     * The aria label of the lower thumb.
    */
    ariaLabelLower?: string;
    /**
     * The aria label of the upper thumb.
    */
    ariaLabelUpper?: string;
    /**
     * Emitted when a value is changed via thumb drag or keyboard interaction.
    */
    input?: (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void;
    /**
     * Emitted when a value change is committed on a thumb drag end or keyboard interaction.
    */
    change?: (s: IgrRangeSlider, e: IgrRangeSliderValueEventArgs) => void;
}
