import * as React from 'react';
import { IgrDropdownItem, IIgrDropdownItemProps } from "./igr-dropdown-item";
import { SelectItem } from "./SelectItem";
/**
 * Represents an item in a select list.
*/
export declare class IgrSelectItem extends IgrDropdownItem<IIgrSelectItemProps> {
    protected createImplementation(): SelectItem;
    /**
                                 * @hidden
                                 */
    get i(): SelectItem;
    constructor(props: IIgrSelectItemProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets the textContent of the item without touching the prefix and suffix content.
    */
    get textContent(): string;
    set textContent(v: string);
}
export interface IIgrSelectItemProps extends IIgrDropdownItemProps {
    /**
     * Sets the textContent of the item without touching the prefix and suffix content.
    */
    textContent?: string;
}
