import * as React from 'react';
import { Toast } from "./Toast";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * A toast component is used to show a notification
*/
export declare class IgrToast<P extends IIgrToastProps = IIgrToastProps> extends React.Component<P, {}> {
    protected createImplementation(): Toast;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Toast; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrToast;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Determines whether the toast is opened.
    */
    get open(): boolean;
    set open(v: boolean);
    /**
     * Determines the time after which the toast will close
    */
    get displayTime(): number;
    set displayTime(v: number);
    /**
     * Determines whether the toast is closed automatically or not.
    */
    get keepOpen(): boolean;
    set keepOpen(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    /**
     * Closes the toast.
    
    */
    hide(): void;
    /**
     * Opens the toast.
    
    */
    show(): void;
    /**
     * Toggles the open state of the toast.
    
    */
    toggle(): void;
    connectedCallback(): void;
}
export interface IIgrToastProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Determines whether the toast is opened.
    */
    open?: boolean | string;
    /**
     * Determines the time after which the toast will close
    */
    displayTime?: number | string;
    /**
     * Determines whether the toast is closed automatically or not.
    */
    keepOpen?: boolean | string;
}
